
(defvar f1        "eval"           )
(defvar f2        "toString"       )
(defvar c1        "Const"          )
(defvar c2        "Add"            )
(defvar f1mod     "EvalMod"        )
(defvar f2mod     "ToStringMod"    )
(defvar f1c1      (concat f1 c1)   )
(defvar f1c2      (concat f1 c2)   )
(defvar f2c1      (concat f2 c1)   )
(defvar f2c2      (concat f2 c2)   )
(defvar c1mod     (concat c1 "Mod"))
(defvar c2mod     (concat c2 "Mod"))

;; 1- use specific names for business functions
(haskell-refac-renameToplevel f1 c1mod f1c1)
(haskell-refac-renameToplevel f1 c2mod f1c2)
(haskell-refac-renameToplevel f2 c1mod f2c1)
(haskell-refac-renameToplevel f2 c2mod f2c2)

;; 2- Unfold business functions
;; replace calls to the business functions by their bodies (unfold)
(haskell-refac-unfoldInstanceIn f1c1 f1 f1mod)
(haskell-refac-unfoldInstanceIn f1c2 f1 f1mod)
(haskell-refac-unfoldInstanceIn f2c1 f2 f2mod)
(haskell-refac-unfoldInstanceIn f2c2 f2 f2mod)

;; 3- remove unused business functions from exports
(haskell-refac-rmFromExports f1c1 c1mod)
(haskell-refac-rmFromExports f2c1 c1mod)
(haskell-refac-rmFromExports f1c2 c2mod)
(haskell-refac-rmFromExports f2c2 c2mod)

;; 4- Delete business functions
(haskell-refac-removeDefCmd f1c1 c1mod)
(haskell-refac-removeDefCmd f1c2 c2mod)
(haskell-refac-removeDefCmd f2c1 c1mod)
(haskell-refac-removeDefCmd f2c2 c2mod)

;; 5- Clean useless imports
(haskell-refac-cleanImportsCmd f1mod)
(haskell-refac-cleanImportsCmd f2mod)


;; remark : compared to the initial view,
;; there are in the result of transfo + way back a pair of additional parenthesis
;; and an additional qualifier for eval and toString.
