(defvar f1        "eval"           )
(defvar f2        "toString"       )
(defvar c1        "Const"          )
(defvar c2        "Add"            )
(defvar f1mod     "EvalMod"        )
(defvar f2mod     "ToStringMod"    )
(defvar f1c1      (concat f1 c1)   )
(defvar f1c2      (concat f1 c2)   )
(defvar f2c1      (concat f2 c1)   )
(defvar f2c2      (concat f2 c2)   )
(defvar c1mod     (concat c1 "Mod"))
(defvar c2mod     (concat c2 "Mod"))
(defvar f1reducer "fold1"          )
(defvar f2reducer "fold2"          )
(defvar dummyc1   "c"              )
(defvar dummyc2   "a"              )
(defvar clientmod "Client"         )


;; use specific names for business functions
(haskell-refac-renameToplevel f1 c1mod f1c1)
(haskell-refac-renameToplevel f1 c2mod f1c2)
(haskell-refac-renameToplevel f2 c1mod f2c1)
(haskell-refac-renameToplevel f2 c2mod f2c2)

;; prepare the generative fold operations :
;; the equations for functions of interest are saved into  comments
(haskell-refac-duplicateIntoComment f1 f1mod)
(haskell-refac-duplicateIntoComment f2 f2mod)

;; unfold the use of the traversal function
;; in the definition of functions of interest
(haskell-refac-unfoldInstanceIn f1reducer f1 f1mod)
(haskell-refac-unfoldInstanceIn f2reducer f2 f2mod)

;; fold the use of the traversal function in the body of the
;; functions of interest in order to find a recursive definition of them
;; (without a call to the traversal function)
(haskell-refac-generativeFold f1reducer "3" f1mod)
(haskell-refac-generativeFold f1reducer "3" f1mod)
(haskell-refac-generativeFold f2reducer "3" f2mod)
(haskell-refac-generativeFold f2reducer "3" f2mod)

;; comments introduced for the generative fold can be deleted
(haskell-refac-rmCommentBefore f1 f1mod)
(haskell-refac-rmCommentBefore f2 f2mod)


;; generative fold has produced case expressions that have
;; to be simplified
(haskell-refac-simplifyCasePattern f1 f1mod)
(haskell-refac-unfoldInstanceIn dummyc2 f1 f1mod)
(haskell-refac-removeLocalDef dummyc2 f1 f1mod)

(haskell-refac-simplifyCasePattern f1 f1mod)
(haskell-refac-unfoldInstanceIn dummyc1 f1 f1mod)
(haskell-refac-removeLocalDef dummyc1 f1 f1mod)

(haskell-refac-simplifyCasePattern f2 f2mod)
(haskell-refac-unfoldInstanceIn dummyc2 f2 f2mod)
(haskell-refac-removeLocalDef dummyc2 f2 f2mod)

(haskell-refac-simplifyCasePattern f2 f2mod)
(haskell-refac-unfoldInstanceIn dummyc1 f2 f2mod)
(haskell-refac-removeLocalDef dummyc1 f2 f2mod)

;; the case expressions introduced by the generative fold 
;; have to be transformed into equations
(haskell-refac-caseToEq f1 f1mod)
(haskell-refac-caseToEq f2 f2mod)


;; replace calls to the business functions by their bodies (unfold)
(haskell-refac-unfoldInstanceIn f1c1 f1 f1mod)
(haskell-refac-unfoldInstanceIn f1c2 f1 f1mod)
(haskell-refac-unfoldInstanceIn f2c1 f2 f2mod)
(haskell-refac-unfoldInstanceIn f2c2 f2 f2mod)

;; business functions are not used an can be deleted 
;; (imports, exports and declarations)
(haskell-refac-cleanImportsCmd f1mod) ;; useless but not costly
(haskell-refac-cleanImportsCmd f2mod) ;; useless

(haskell-refac-rmFromExports f1c1 c1mod)
(haskell-refac-rmFromExports f2c1 c1mod)
(haskell-refac-rmFromExports f1c2 c2mod)
(haskell-refac-rmFromExports f2c2 c2mod)


(haskell-refac-removeDefCmd f1c1 c1mod)
(haskell-refac-removeDefCmd f1c2 c2mod)
(haskell-refac-removeDefCmd f2c1 c1mod)
(haskell-refac-removeDefCmd f2c2 c2mod)



;; the traversal functions can be deleted
(haskell-refac-removeDefCmd f1reducer f1mod)
(haskell-refac-removeDefCmd f2reducer f2mod)
