(defvar f1        "eval"           )
(defvar f2        "toString"       )
(defvar c1        "Const"          )
(defvar c2        "Add"            )
(defvar f1mod     "EvalMod"        )
(defvar f2mod     "ToStringMod"    )
(defvar f1c1      (concat f1 c1)   )
(defvar f1c2      (concat f1 c2)   )
(defvar f2c1      (concat f2 c1)   )
(defvar f2c2      (concat f2 c2)   )
(defvar c1mod     (concat c1 "Mod"))
(defvar c2mod     (concat c2 "Mod"))


;; 1- set branches as local definitions (preliminary to exhibit business functions)
(haskell-refac-exhibitFunction f1 c1 f1c1 f1mod)
(haskell-refac-exhibitFunction f1 c2 f1c2 f1mod)
(haskell-refac-exhibitFunction f2 c1 f2c1 f2mod)
(haskell-refac-exhibitFunction f2 c2 f2c2 f2mod)

;; 2- abstract these definitions over local arguments to create business functions
(haskell-refac-generalise f1 c1 f1c1 f1mod "0" "x" "Curried"   "OtherType")
(haskell-refac-generalise f2 c1 f2c1 f2mod "0" "x" "Curried"   "OtherType")
(haskell-refac-generalise f1 c2 f1c2 f1mod "1" "y" "UnCurried" "OtherType")
(haskell-refac-generalise f1 c2 f1c2 f1mod "0" "x" "UnCurried" "OtherType") 
(haskell-refac-generalise f2 c2 f2c2 f2mod "1" "y" "UnCurried" "OtherType")
(haskell-refac-generalise f2 c2 f2c2 f2mod "0" "x" "UnCurried" "OtherType")

;; 3- make main functions abstract in business functions to avoid circular dependencies
(haskell-refac-generaliseIdent f1 f1mod f1 "cont")
(haskell-refac-generaliseIdent f2 f2mod f2 "cont")

;; 4- lift the business functions to the top-level
(haskell-refac-makeGlobalOfLocalIn f1 f1c1 f1mod)
(haskell-refac-makeGlobalOfLocalIn f1 f1c2 f1mod)
(haskell-refac-makeGlobalOfLocalIn f2 f2c1 f2mod)
(haskell-refac-makeGlobalOfLocalIn f2 f2c2 f2mod) 

;; 5- move business functions to the appropriate modules
(haskell-refac-moveDefBetweenModules f1c1 f1mod c1mod)
(haskell-refac-moveDefBetweenModules f1c2 f1mod c2mod)
(haskell-refac-moveDefBetweenModules f2c1 f2mod c1mod)
(haskell-refac-moveDefBetweenModules f2c2 f2mod c2mod) 

;; 6- rename the business functions to make them share the same name
(haskell-refac-renameToplevel f1c1 c1mod f1)
(haskell-refac-renameToplevel f1c2 c2mod f1)
(haskell-refac-renameToplevel f2c1 c1mod f2)
(haskell-refac-renameToplevel f2c2 c2mod f2) 
