(defvar f1        "eval"           )
(defvar f2        "toString"       )
(defvar c1        "Const"          )
(defvar c2        "Add"            )
(defvar f1mod     "EvalMod"        )
(defvar f2mod     "ToStringMod"    )
(defvar f1c1      (concat f1 c1)   )
(defvar f1c2      (concat f1 c2)   )
(defvar f2c1      (concat f2 c1)   )
(defvar f2c2      (concat f2 c2)   )
(defvar c1mod     (concat c1 "Mod"))
(defvar c2mod     (concat c2 "Mod"))
(defvar f1reducer "fold1"          )
(defvar f2reducer "fold2"          )
(defvar dummyc1   "c"              )
(defvar dummyc2   "a"              )
(defvar clientmod "Client"         )


;; set branches as local definitions (preliminary to exhibit business functions)
(haskell-refac-exhibitFunction f1 c1 f1c1 f1mod)
(haskell-refac-exhibitFunction f1 c2 f1c2 f1mod)
(haskell-refac-exhibitFunction f2 c1 f2c1 f2mod)
(haskell-refac-exhibitFunction f2 c2 f2c2 f2mod) 



;; abstract these definitions over local arguments to create business functions
(haskell-refac-generalise f1 c1 f1c1 f1mod "0" "x" "Curried" "OtherType")
(haskell-refac-generalise f2 c1 f2c1 f2mod "0" "x" "Curried" "OtherType")
(haskell-refac-generalise f2 c2 f2c2 f2mod "1" "y" "UnCurried" "RecType")
(haskell-refac-generalise f2 c2 f2c2 f2mod "0" "x" "UnCurried" "RecType")
(haskell-refac-generalise f1 c2 f1c2 f1mod "1" "y" "UnCurried" "RecType")
(haskell-refac-generalise f1 c2 f1c2 f1mod "0" "x" "UnCurried" "RecType") 

;; lift the business functions to the top-level
(haskell-refac-makeGlobalOfLocalIn f1 f1c1 f1mod)
(haskell-refac-makeGlobalOfLocalIn f1 f1c2 f1mod)
(haskell-refac-makeGlobalOfLocalIn f2 f2c1 f2mod)
(haskell-refac-makeGlobalOfLocalIn f2 f2c2 f2mod) 


;; abstract the functions of interest over the business functions 
(haskell-refac-generaliseIdent f1 f1mod f1c1 dummyc1)
(haskell-refac-generaliseIdent f1 f1mod f1c2 dummyc2)
(haskell-refac-generaliseIdent f2 f2mod f2c1 dummyc1)
(haskell-refac-generaliseIdent f2 f2mod f2c2 dummyc2) 

;; rename these functions of interest (they have become traversal functions)
(haskell-refac-renameToplevel f1 f1mod f1reducer)
(haskell-refac-renameToplevel f2 f2mod f2reducer) 


;; reconstruct the functions of interest as calls to the traversal functions
;; with appropriate arguments
(haskell-refac-newDefFunApp f1reducer "3" f1 clientmod)
(haskell-refac-newDefFunApp f2reducer "3" f2 clientmod) 
(haskell-refac-makeGlobalOfLocal f1 clientmod)
(haskell-refac-makeGlobalOfLocal f2 clientmod) 
(haskell-refac-generaliseIdent f1 clientmod "e1" "x") 
(haskell-refac-generaliseIdent f2 clientmod "e1" "x") 

(haskell-refac-foldToplevelDefinition f1 clientmod)
(haskell-refac-foldToplevelDefinition f2 clientmod)

(haskell-refac-moveDefBetweenModules f1 clientmod f1mod )
(haskell-refac-moveDefBetweenModules f2 clientmod f2mod ) 

(haskell-refac-unfoldInstanceIn (concat f1 "_gen") f1 f1mod)
(haskell-refac-unfoldInstanceIn (concat f1 "_gen_1") f1 f1mod)
(haskell-refac-unfoldInstanceIn (concat f2  "_gen") f2 f2mod)
(haskell-refac-unfoldInstanceIn (concat f2  "_gen_1") f2 f2mod) 
(haskell-refac-removeDefCmd (concat f1 "_gen") f1mod)
(haskell-refac-removeDefCmd (concat f1 "_gen_1") f1mod)
(haskell-refac-removeDefCmd (concat f2 "_gen") f2mod)
(haskell-refac-removeDefCmd (concat f2 "_gen_1") f2mod) 


;; move business functions to the appropriate modules
(haskell-refac-moveDefBetweenModules f1c1 f1mod c1mod)
(haskell-refac-moveDefBetweenModules f1c2 f1mod c2mod)
(haskell-refac-moveDefBetweenModules f2c1 f2mod c1mod)
(haskell-refac-moveDefBetweenModules f2c2 f2mod c2mod) 


;; rename the business functions to make them share the same name
(haskell-refac-renameToplevel f1c1 c1mod f1)
(haskell-refac-renameToplevel f1c2 c2mod f1)
(haskell-refac-renameToplevel f2c1 c1mod f2)
(haskell-refac-renameToplevel f2c2 c2mod f2) 
